/** MuckConn - Muck Connector version 3
 * Handles the different muck addresses
 * and characters, and physical connection
 * Now as a separate class callable from other parts of JMUD
 * $Id: MuckConn.java,v 1.26 2004/07/28 03:13:05 jeffnik Exp $
 */

/* JamochaMUD, a Muck/Mud client program
 * Copyright (C) 1998-2004  Jeff Robinson
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

package anecho.JamochaMUD;

import java.awt.*;
import java.awt.event.*;

// import java.util.Hashtable;
import java.util.Vector;

// import anecho.gui.SyncFrame;
// import anecho.gui.SyncFrameGroup;
import anecho.gui.PosTools;
import anecho.gui.ResReader;

// import plugins.*;

	/** MuckConn - Muck Connector version 2
	 * Handles the different muck addresses
	 * and characters, and physical connection
         * @version $Id: MuckConn.java,v 1.26 2004/07/28 03:13:05 jeffnik Exp $
         * @author Jeff Robinson
	 */
// public class MuckConn implements ActionListener, WindowListener {
public class old_MuckConn extends Dialog implements ActionListener, WindowListener {

    private Vector editName = new Vector(0, 1);
    private Vector editAddy = new Vector(0, 1);
    private Vector editPort = new Vector(0, 1);

    // private static Button connectButton;
    private Button connButton;
    // private static Choice jmMUNames;
    private Choice jmMUNames;
    // private SyncFrame jmMCFrame;
    // private Dialog jmMCFrame;
    // private int minimizedLineCount;
    // private SyncFrameGroup syncGroup;
    // private GridBagLayout muckConnLayout;
    // private GridBagConstraints constraints;
    // private Image jamochaMUDImage;
    private JMConfig settings;
    // private CHandler connHandler;
    private String chosenName = null;
    private String finalAddress = null;
    private int chosenPort;

    private static final boolean DEBUG = false;

    // public MuckConn(CHandler callBack, JMConfig settings){
    public old_MuckConn(JMConfig settings){
        super(settings.getJMFrame(JMConfig.MUCKMAINFRAME), "JamochaMUD (Connector)", true);
        // this.connHandler = callBack;
        this.settings = settings;

        GridBagLayout mCLayout;
        GridBagConstraints constraints;

        // syncGroup = new SyncFrameGroup();
        mCLayout = new GridBagLayout();
        constraints = new GridBagConstraints();

        // editName = settings.getMuckName();
        //editAddy = settings.getMuckAddy();
        // editPort = settings.getMuckPort();
        editName = settings.getJMVector(JMConfig.MUCKNAME);
        editAddy = settings.getJMVector(JMConfig.MUCKADDY);
        editPort = settings.getJMVector(JMConfig.MUCKPORT);

        // Set new layout
        // jmMCFrame = new SyncFrame("JamochaMUD (Connector)");
        // jmMCFrame = new Dialog(settings.getJMFrame(JMConfig.MUCKMAINFRAME), "JamochaMUD (Connector)");
        // jmMCFrame.addWindowListener(this);
//        addWindowListener(this);
        // jmMCFrame.setCloseState(true);
        // jmMCFrame.setTerminationState(true);

        // jmMCFrame.setLayout(mCLayout);
        setLayout(mCLayout);

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        jmMUNames = new Choice();
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.gridheight = 1;
        constraints.gridx = 0;
        constraints.gridy = 0;
        constraints.weightx = 1;
        constraints.weighty = 0;
        constraints.insets = new Insets(7, 7, 2, 7);
        constraints.fill = GridBagConstraints.BOTH;
        constraints.anchor = GridBagConstraints.CENTER;
        mCLayout.setConstraints(jmMUNames, constraints);
        // jmMCFrame.add(jmMUNames);
        add(jmMUNames);

        connButton = new Button(RB("connect"));
        constraints.gridwidth = 2;
        constraints.gridheight = 1;
        constraints.gridx = 0;
        constraints.gridy = 1;
        constraints.weightx = 1;
        constraints.weighty = 0;
        constraints.insets = new Insets(2, 7, 2, 2);
        constraints.fill = GridBagConstraints.BOTH;
        constraints.anchor = GridBagConstraints.CENTER;
        mCLayout.setConstraints(connButton, constraints);
        // jmMCFrame.add(connButton);
        add(connButton);
        connButton.addActionListener(this);
        connButton.setActionCommand("ConnectToMU");

        Button tempB = new Button(RB("addMU"));
        constraints.gridwidth = GridBagConstraints.RELATIVE;
        constraints.gridheight = 1;
        constraints.gridx = 2;
        constraints.gridy = 1;
        constraints.weightx = 1;
        constraints.weighty = 0;
        constraints.insets = new Insets(2, 2, 2, 2);
        constraints.fill = GridBagConstraints.BOTH;
        constraints.anchor = GridBagConstraints.CENTER;
        mCLayout.setConstraints(tempB, constraints);
        // jmMCFrame.add(tempB);
        add(tempB);
        tempB.addActionListener(this);
        tempB.setActionCommand("AddMU");

        tempB = new Button(RB("removeMU"));
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.gridheight = 1;
        constraints.gridx = 4;
        constraints.gridy = 1;
        constraints.weightx = 1;
        constraints.weighty = 0;
        constraints.insets = new Insets(2, 2, 2, 7);
        constraints.fill = GridBagConstraints.BOTH;
        constraints.anchor = GridBagConstraints.CENTER;
        mCLayout.setConstraints(tempB, constraints);
        // jmMCFrame.add(tempB);
        add(tempB);
        tempB.addActionListener(this);
        tempB.setActionCommand("RemoveMU");

		tempB = new Button(RB("editMU"));
			constraints.gridx = 0;
			constraints.gridy = 2;
                        constraints.gridwidth = GridBagConstraints.RELATIVE;
			constraints.gridheight = 1;
			constraints.weightx = 1;
			constraints.weighty = 0;
			constraints.insets = new Insets(2, 7, 7, 2);
			constraints.fill = GridBagConstraints.NONE;
			constraints.anchor = GridBagConstraints.CENTER;
                        // jmMCFrame.add(tempB);
                        add(tempB);
			mCLayout.setConstraints(tempB, constraints);
		tempB.addActionListener(this);
		tempB.setActionCommand("EditMU");

                // tempB = new Button(RB("pingMU"));
                tempB = new Button(RB("dontConnect"));
	                constraints.gridwidth = GridBagConstraints.REMAINDER;
			constraints.gridheight = GridBagConstraints.REMAINDER;
			constraints.gridx = 3;
			constraints.gridy = 2;
			constraints.weightx = 1;
			constraints.weighty = 0;
			constraints.insets = new Insets(2, 2, 7, 7);
			constraints.fill = GridBagConstraints.NONE;
			constraints.anchor = GridBagConstraints.CENTER;
                        // jmMCFrame.add(tempB);
                        add(tempB);
			mCLayout.setConstraints(tempB, constraints);
                // tempB.setActionCommand("PingMU");
                tempB.setActionCommand("DontConnect");
		tempB.addActionListener(this);
                // tempB.setEnabled(false);

                Point tPoint = PosTools.findCenter();
                // jmMCFrame.setLocation(tPoint.x - 237, tPoint.y - 185);
                setLocation(tPoint.x - 237, tPoint.y - 185);
                // jmMCFrame.setSize(475, 370);

                // jmMCFrame.pack();
                pack();

                // Add the list of MU*s, set the icon, etc.
                jmStartUp();
                // jmMCFrame.setVisible(true);
                // settings.setJMValue(JMConfig.MUCKCONNVISIBLE, true);

	}

    /*
    public void setVisible(boolean vis) {
        System.out.println("MuckConn.setVisible(" + vis + ")");
        jmMCFrame.setVisible(vis);
        settings.setJMValue(JMConfig.MUCKCONNVISIBLE, vis);
    }

    public boolean isVisible() {
        boolean retres = settings.getJMboolean(JMConfig.MUCKCONNVISIBLE);
        return retres;
    }
    */

    public void actionPerformed(ActionEvent event){

        String arg = event.getActionCommand();

        if (arg.equals("ConnectToMU")) {
            // Connect to the MU* displayed
            connectToMU();
        }

        if (arg.equals("EditMU")) {
            // Edit the MU*
            editMU();
        }

        if (arg.equals("RemoveMU")) {
            // Remove the MU*
            removeMU();
        }

        if (arg.equals("AddMU")) {
            // Add MU*
            addMU();
        }

        /* This one may never be added.  Fix me XXX */
        /*
        if (arg.equals("PingMU")) {
            // Ping the MU*
            }
            */

        /* Start JamochaMUD but don't make any connection */
        if (arg.equals("DontConnect")) {
            // jmMCFrame.setVisible(false);
            setVisible(false);

            // MuckMain mm = settings.getMainWindowVariable();
            Frame mmFrame = settings.getJMFrame(JMConfig.MUCKMAINFRAME);
            if (!mmFrame.isVisible()) {
                mmFrame.setVisible(true);
            }

            settings.setJMValue(JMConfig.MUCKCONNVISIBLE, false);

            // Send the focus to out main program... just a nice thing to do
            // settings.getMainWindowVariable().requestFocus();
            mmFrame.requestFocus();
        }

    }

    public void windowActivated(WindowEvent event) {}

    public void windowClosed(WindowEvent event) {}

    public void windowClosing(WindowEvent event) {
        // If there are active connections then we'll just close this
        // dialogue and return to the action!  Otherwise, we'll
        // shut down the entire program

        // There may be a better way of doing this.  Fix Me XXX
        settings.setJMValue(JMConfig.MUCKCONNVISIBLE, false);
        CHandler connHandler = settings.getConnectionHandler();
        if (connHandler.totalConnections() > 0) {
            // jmMCFrame.setTerminationState(false);
            // jmMCFrame.setVisible(false);
            // jmMCFrame.dispose();
            setVisible(false);
            dispose();
            return;
        }
    }

    public void windowDeactivated(WindowEvent event) {}

    public void windowDeiconified(WindowEvent event) {}

    public void windowIconified(WindowEvent event) {}

    public void windowOpened(WindowEvent event) {}
    /**
     * This is a generic bit to access the
     * ResReader.class, for localization
     * (Multi-language support)
     */
    // private static String RB(String itemTarget) {
    private synchronized String RB(String itemTarget) {
        ResReader reader = new ResReader();
        // return reader.LangString("JamochaMUDBundle", itemTarget);
        return reader.LangString(JMConfig.BUNDLEBASE, itemTarget);
    }

    /**
     * Call the methods necessary for the user to add
     * a new MUD/MUCK to the list of worlds
     */
    private void addMU() {

        // int i = jmMUNames.getSelectedIndex();

        // Call the AddEdit box
        // AddEdit addMU = new AddEdit(jmMCFrame, RB("addMU"));
        AddEdit addMU = new AddEdit(settings.getJMFrame(JMConfig.MUCKMAINFRAME), RB("addMU"));
        addMU.setSize(280, 160);
        // addMU.setLocation(PosTools.findCenter(jmMCFrame, addMU));
        addMU.setLocation(PosTools.findCenter(this, addMU));
        addMU.setVisible(true);

        if (addMU.isOkay()) {
            String jmEditName = addMU.getName();
            String jmEditAddy = addMU.getAddress();
            String jmEditPort = addMU.getPort();

            jmEditName.trim();
            jmEditAddy.trim();
            jmEditPort.trim();

            if (!jmEditName.equals("") && !jmEditAddy.equals("") && !jmEditPort.equals("")) {
                // Check to see if the first entry is a 'valid'
                // MU*, or just a place-marker
                if ((settings.getJMVector(JMConfig.MUCKNAME)).size() < 1) {
                    // if (editName.elementAt(0).equals("None") & editAddy.elementAt(0).equals("----")) {
                    jmMUNames.removeAll();
                }

                // Add the new entry to the list of available MU*s
                editName.addElement(jmEditName);
                editAddy.addElement(jmEditAddy);
                editPort.addElement(jmEditPort);
                jmMUNames.addItem(jmEditName + " (" + jmEditAddy + " Port: " + jmEditPort + ")");
                // Put new vector into the hashtable
                //settings.setMuckName(editName);
                //settings.setMuckAddy(editAddy);
                // settings.setMuckPort(editPort);
                settings.setJMValue(JMConfig.MUCKNAME, editName);
                settings.setJMValue(JMConfig.MUCKADDY, editAddy);
                settings.setJMValue(JMConfig.MUCKPORT, editPort);

                // Display new MU* in choice
                jmMUNames.select(jmMUNames.getItemCount() - 1);
                connButton.requestFocus();

            }
        }

    }

    /**
     * Remove the currently selected MUD/MUCK from the list
     * of available worlds (and the .jamocha.rc file).
     */
    private void removeMU() {
        // Remove MU* from list
        Vector muckName = new Vector(0, 1);
        Vector muckAddy = new Vector(0, 1);
        Vector muckPort = new Vector(0, 1);
        // muckName = settings.getMuckName();
        // muckAddy = settings.getMuckAddy();
        // muckPort = settings.getMuckPort();
        muckName = settings.getJMVector(JMConfig.MUCKNAME);
        muckAddy = settings.getJMVector(JMConfig.MUCKADDY);
        muckPort = settings.getJMVector(JMConfig.MUCKPORT);

        muckName.removeElementAt(jmMUNames.getSelectedIndex());
        muckAddy.removeElementAt(jmMUNames.getSelectedIndex());
        muckPort.removeElementAt(jmMUNames.getSelectedIndex());

        if (muckName.size() < 1) {
            jmMUNames.removeAll();
            muckName.addElement("None");
            muckAddy.addElement("----");
            muckPort.addElement("----");
            // jmMUNames.addItem("None" + " (" + "----" + " Port: " + "----" + ")");
            jmMUNames.addItem("None (---- Port: ----)");
        } else {
            jmMUNames.remove(jmMUNames.getSelectedIndex());
        }

        // Now place the vectors back in the Hashtable
        // settings.setMuckName(muckName);
        // settings.setMuckAddy(muckAddy);
        // settings.setMuckPort(muckPort);
        settings.setJMValue(JMConfig.MUCKNAME, muckName);
        settings.setJMValue(JMConfig.MUCKADDY, muckAddy);
        settings.setJMValue(JMConfig.MUCKPORT, muckPort);
    }

    /**
     * The user has opted to connect to the currently selected
     * MUD/MUCK, so we honour their wishes here!
     */
    private void connectToMU() {

        Vector tempAddy = new Vector(0, 1);
        Vector tempPort = new Vector(0, 1);

        tempAddy = settings.getJMVector(JMConfig.MUCKADDY);
        tempPort = settings.getJMVector(JMConfig.MUCKPORT);

        if (tempAddy.size() < 1) {
            // We don't have any valid MU*'s listed
            return;
        }

        if (DEBUG) {
            System.err.println("MuckConn.JMConnectToMU setVisible(false)");
        }

        // jmMCFrame.setVisible(false);
        // setVisible(false);
        //  System.out.println("MuckConn set jmMCFrame invisible");

        // MuckMain mainFrame = settings.getMainWindowVariable();
        Frame mainFrame = settings.getJMFrame(JMConfig.MUCKMAINFRAME);

        if (!mainFrame.isVisible()) {
            mainFrame.setVisible(true);
            //  System.out.println("MuckConn set MuckMain set visible");
        }

        int selection = jmMUNames.getSelectedIndex();

        chosenName = editName.elementAt(selection).toString();
        finalAddress = tempAddy.elementAt(selection).toString();
        chosenPort = (Integer.parseInt(tempPort.elementAt(selection).toString()));

        //  System.out.println("Getting variables.");
        settings.setJMValue(JMConfig.CONNMUCK, finalAddress);
        settings.setJMValue(JMConfig.CONNPORT, chosenPort);
        settings.setJMValue(JMConfig.LASTMU, jmMUNames.getSelectedItem());

        /*
        if (DEBUG) {
            System.err.println("MuckConn.JMConnectToMU calling open Socket!?!?!?!");
        }

        MuSocket msock = connHandler.OpenSocket(chosenName, finalAddress, chosenPort);
        if (DEBUG) {
            System.err.println("MuckConn.JMConnectToMU adding MU to display");
        }
        connHandler.addNewMU(chosenName, finalAddress, chosenPort, msock);
        if (DEBUG) {
            System.err.println("MuckConn.JMConnectToMU new MU* added.");
            }
            */
        // connHandler.setVisibleMU();

        /*
        mainFrame.addNewMU(msock);
        mainFrame.setVisibleMU();
        */
        setVisible(false);

        // We only want to set the Main Layout once
        if (!settings.getJMboolean(JMConfig.MAINLAYOUTVALID)) {
            //  System.out.println("MuckConn calling tempMain.setMainLayout()");
            // mainFrame.setMainLayout();
            (settings.getMainWindowVariable()).setMainLayout();
        }

        settings.setJMValue(JMConfig.MUCKCONNVISIBLE, false);
        // mainWindow.setVisibleMU();  // XXX removed for trouble-shooting

        // settings.getMainWindowVariable().setMainLayout();

        // System.out.println("MuckConn.JMConnectToMU requesting focus of main window.");
        // Send the focus to out main program... just a nice thing to do
        // settings.getMainWindowVariable().requestFocus();
        //  System.out.println("MuckConn calling tempMain.requestFocus()");
        if (DEBUG) {
            System.err.println("MuckConn.JMConnectToMU returning focus to main frame.");
        }
        mainFrame.requestFocus();
        // settings.getMainWindowVariable().setVisibleMU();
        // System.out.println("MuckConn.JMConnectToMU focused.");

        }

        /**
	 * Call the methods to allow the user to edit the MUD/MUCK
	 * Name/address/port of the currently selected world
	 */
	private void editMU() {
            // edit current MU* entry
            // AddEdit editBox = new AddEdit(jmMCFrame, RB("editMU"));
            AddEdit editBox = new AddEdit(settings.getJMFrame(JMConfig.MUCKMAINFRAME), RB("editMU"));

            int index = jmMUNames.getSelectedIndex();
            editBox.setName((String)editName.elementAt(index));
            editBox.setAddress((String)editAddy.elementAt(index));
            editBox.setPort((String)editPort.elementAt(index));
            editBox.setSize(280, 160);
            // editBox.setLocation(PosTools.findCenter(jmMCFrame, editBox));
            editBox.setLocation(PosTools.findCenter(this, editBox));
            editBox.setVisible(true);

            // Call the AddEdit box

            if (editBox.isOkay()) {
                String jmEditName = editBox.getName();
                String jmEditAddy = editBox.getAddress();
                String jmEditPort = editBox.getPort();

                jmEditName.trim();
                jmEditAddy.trim();
                jmEditPort.trim();

                if (!jmEditName.equals("") && !jmEditAddy.equals("") && !jmEditPort.equals("")) {
                    // Replace the edited MU* info
                    editName.removeElementAt(index);
                    editAddy.removeElementAt(index);
                    editPort.removeElementAt(index);

                    editName.insertElementAt(jmEditName, index);
                    editAddy.insertElementAt(jmEditAddy, index);
                    editPort.insertElementAt(jmEditPort, index);

                    // Put new vector into the hashtable
                    // settings.setMuckName(editName);
                    // settings.setMuckAddy(editAddy);
                    // settings.setMuckPort(editPort);
                    settings.setJMValue(JMConfig.MUCKNAME, editName);
                    settings.setJMValue(JMConfig.MUCKADDY, editAddy);
                    settings.setJMValue(JMConfig.MUCKPORT, editPort);

                    // Replace the choice entry
                    jmMUNames.remove(index);
                    jmMUNames.insert(jmEditName + " (" + jmEditAddy + " Port: " + jmEditPort + ")", index);
                    jmMUNames.select(index);
                    connButton.requestFocus();

                }
            }
        }

    /** Initialise all the starting windows and such
     *
     */
    private void jmStartUp() {

        // Read in the environmental variables
        /*
        MediaTracker tracker = new MediaTracker(jmMCFrame);
        Class testC = this.getClass();
        jamochaMUDImage = Toolkit.getDefaultToolkit().getImage(testC.getResource("kehza.gif"));

        // jamochaMUDImage = Toolkit.getDefaultToolkit().getImage("kehza.gif");
        tracker.addImage(jamochaMUDImage, 0, 16, 16);
        try {
            tracker.waitForAll();
        } catch (Exception e) {
            System.out.println("Icon load error.  Exception " + e);
        }

        settings.setIconImage(jamochaMUDImage);

        jmMCFrame.setIconImage(jamochaMUDImage);
        */

        // set up the Muck Name variables
        compileNames();

    }

    /**
     * Compile the MU* names
     * and then write them into the
     * choice of jmMCFrame
     */
    private void compileNames() {
        // First grab the vectors
        Vector muckAddy = new Vector(0, 1);
        Vector muckName = new Vector(0, 1);
        Vector muckPort = new Vector(0, 1);

        // muckName = settings.getMuckName();
        // muckAddy = settings.getMuckAddy();
        // muckPort = settings.getMuckPort();
        muckName = settings.getJMVector(JMConfig.MUCKNAME);
        muckAddy = settings.getJMVector(JMConfig.MUCKADDY);
        muckPort = settings.getJMVector(JMConfig.MUCKPORT);

        /* We have no listed MU*'s, so we'll put in a default */
        if (muckName.size() < 1) {
            muckName.addElement("None");
            muckAddy.addElement("----");
            muckPort.addElement("----");
        }

        for (int i=0; i < muckName.size(); i++) {
            jmMUNames.addItem(muckName.elementAt(i) + " (" + muckAddy.elementAt(i) + " Port: " + muckPort.elementAt(i) + ")");
        }


        // Set the 'focus' on the last-selected MU*
        // if (settings.getLastMU() != null) {
        if (settings.getJMString(JMConfig.LASTMU) != null) {
            // try {
            // jmMUNames.select(settings.getLastMU());
            jmMUNames.select(settings.getJMString(JMConfig.LASTMU));
            // } catch (Exception e) {
            // There may not have been a previous selection
        }

    }

    public String getName() {
        return chosenName;
    }

    public String getAddress() {
        return finalAddress;
    }

    public int getPort() {
        return chosenPort;
    }
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {
        // Fix ME XXX - For right now we're just going to ignore this event
        setVisible(false);
        dispose();

        // If the main window is not visible then we'll terminate the program.
        if (!(settings.getJMFrame(settings.MUCKMAINFRAME)).isVisible()) {
            System.exit(0);
        }
    }
}
